#!/usr/bin/perl

#--------ライブラリ読込み------------------------

$commonpl='lib/common.pl';
if(!-e $commonpl){
	&error("$commonplがありません。");
}
require $commonpl;

$common2pl='lib/common2.cgi';
if(!-e $common2pl){
	&error("$common2plがありません。");
}
require $common2pl;

if(!-e $passlog){
	&error("passlogがありません。");
}
require $passlog;

#-------変数-------------------------------------

$maxsize='1000000';
$t_size='10pt';
$t_color='#000000';
$l_color='#0000ff';
$b_color='#ffffff';
$c_valid='365';
@avoid=('<table','<td','<tr','<meta','<form','<embed','script','<style','<body','<!--','<link','<input','style *=','<object','frame','on[a-zA-Z ]+=','expression');

#-------------------------------------------------

$FORM{'page'}=0;


if($ENV{'CONTENT_TYPE'} =~ /multipart\/form-data/){
	&DecodeMulti;
}
else{
	&Decode;
}

sub DecodeMulti{
my($ref,$in_ref,$incfn_ref,$inct_ref,
$name,$value,
$o,$d,$upflag,$upnflag,$filename,$ctype,$okflag,
$csvfilename,$t_fname,$na,@tmp,$dum,$app,$ext,$imgfilename,$upidx
);

unless(-e "lib/cgi_lib.pl"){
	&error("cgi_lib.plがありません。");
}
require 'lib/cgi_lib.pl';

($ref,$in_ref,$incfn_ref,$inct_ref)=&ReadParse;
$upidx=0;
foreach $name(@{$ref}){
	if ($name !~/^upfile/) {
		$value=${$in_ref}{$name};
		if($value=~/\0/){
			&error("不適切な投稿である可能性があります。");
		}
		$value=~s/&/&amp;/g;
		$value=~s/,/&#44;/g;
		$value=~s/'/&#039;/g;
		if($name eq "message"){
			if($hanren){
				if($value=~/([\x21-\x7E]{$hanren_m}?)/){
					&error("不適切な投稿である可能性があります。");
				}
			}
			if(!$tag){
				$value=~s/</&lt;/g;
				$value=~s/>/&gt;/g;
				$value=~s/"/&quot;/g;
			}
			$value=~s/\x0D\x0A/<br>/g;
			$value=~s/\x0D/<br>/g;
			$value=~s/\x0A/<br>/g;
			if($tag){
				&TagCheck(\$value);
			}
		}
		else{
			$value=~s/</&lt;/g;
			$value=~s/>/&gt;/g;
			$value=~s/"/&quot;/g;
			$value=~s/\x0D\x0A//g;
			$value=~s/\x0D//g;
			$value=~s/\x0A//g;
		}
		$FORM{$name}=$value;
	}
	else{
		$upflag=0;
		$upnflag=0;
		$filename="";
		$ctype="";
		$okflag=0;
		$kflag=0;
		$sflag=0;
		$upnflag=1;
		$filename=${$incfn_ref}{$name};
		$ctype=${$inct_ref}{$name};
		$CTYPE{$name}=$ctype;
		if($filename){
			($dum,$app)=split(/\//,$ctype);
			if($app eq "gif"){
				$ext='.gif';
				$okflag=1;
			}
			elsif($app eq "pjpeg" || $app eq "jpeg"){
				$ext='.jpg';
				$okflag=1;
			}
			if(!$okflag){
				&error("アップできる画像はJPEG、GIFファイルのみです。");
			}

			$imgfile=time.$$.$ext;
			$imgfilename = $upimgdir.$imgfile;
			$UPFNAME[$upidx]=$imgfile;
			$upidx++;
			unless(open(IMAGE,">$imgfilename")){
				&error("画像のアップロードに失敗しました");
			}
			binmode(IMAGE);
			binmode(STDOUT);
			print IMAGE ${$in_ref}{$name};
			close(IMAGE);
			$upflag=1;
		}
	}
}

}



sub Decode{
my($name,$value,$buff,@pairs,$pair,$d,$n);

if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'} > $maxsize){
		&error("投稿量が多すぎます。");
	}
	read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
}
else{
	$buff=$ENV{'QUERY_STRING'};
}

if($buff){
	@pairs=split(/&/,$buff);
	foreach $pair(@pairs){
		($name,$value)=split(/=/,$pair);
		$value=~tr/+/ /;
		$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
		$value=~s/&/&amp;/g;
		$value=~s/,/&#44;/g;
		$value=~s/'/&#039;/g;
		if($name eq "message" || $name =~/^comment/){
			if(!$tag){
				$value=~s/</&lt;/g;
				$value=~s/>/&gt;/g;
				$value=~s/"/&quot;/g;
			}
			$value=~s/\x0D\x0A/<br>/g;
			$value=~s/\x0D/<br>/g;
			$value=~s/\x0A/<br>/g;
		}
		elsif($name eq "khost" || $name eq "kword"){
			$value=~s/\x0D\x0A/\n/g;
			$value=~s/\x0D/\n/g;
			$value=~s/\x0A/\n/g;
			$value=~s/"/&quot;/g;
		}
		else{
			$value=~s/</&lt;/g;
			$value=~s/>/&gt;/g;
			$value=~s/"/&quot;/g;
			$value=~s/\x0D\x0A//g;
			$value=~s/\x0D//g;
			$value=~s/\x0A//g;
		}
		if($name eq "number"){
			push(@delnum,$value);
		}
		elsif($name =~/^comment/){
			($d,$n)=split(/_/,$name);
			if($value){
				$COM{$n}=$value;
			}
		}
		elsif($name =~/^alist/){
			push @adtmp,$value;
		}
		elsif($name eq "icondelname"){
			push @icondelname,$value;
		}
		$FORM{$name}=$value;
	}
}

}


$FORM{'name'}=~s/\://g;
$FORM{'home'}=~s/http\:\/\///g;

if($ENV{'SCRIPT_NAME'}){
	$c_name=$ENV{'SCRIPT_NAME'};
}
else{
	$c_name="bbsadmin";
}


if($FORM{'mode'} eq "menu"){
	&Menu;
}
elsif($FORM{'mode'} eq "kiji"){
	&Admin;
}
elsif($FORM{'mode'} eq "del"){
	&Del;
}
elsif($FORM{'mode'} eq "edit"){
	&Edit;
}

elsif($FORM{'mode'} eq "editregist"){
	&EditRegist;
}

elsif($FORM{'mode'} eq "login"){
	&Login;
}
elsif($FORM{'mode'} eq "tmp"){
	&Tmp;
}
elsif($FORM{'mode'} eq "tmpdel"){
	if($FORM{'edt'} eq '削除'){
		&TmpDel;
	}
	else{
		&TmpRegist;
	}
}
elsif($FORM{'mode'} eq "admin"){
	&Admin;
}
elsif($FORM{'mode'} eq "multires"){
	&MultiRes;
}
elsif($FORM{'mode'} eq "multiresregist"){
	&MultiResRegist;
}

elsif($FORM{'mode'} eq "dl"){
	&Dl;
}
elsif($FORM{'mode'} eq "env"){
	&Env;
}
elsif($FORM{'mode'} eq "envregist"){
	&EnvRegist;
}
elsif($FORM{'mode'} eq "iconviewdel"){
	&IconViewDel;
}
elsif($FORM{'mode'} eq "icondel"){
	&IconDel;
}
else{
	&Login;
}


sub TagCheck{
my $ref=$_[0];
foreach(@avoid){
	if(${$ref}=~/$_/i){
		&error("禁止タグが含まれています。");
	}
}
}


sub GetCookie{
my($name,$value,$pair,@pairs,$cookies);
$cookies=$ENV{'HTTP_COOKIE'};
@pairs=split(/;/,$cookies);
foreach $pair(@pairs){
	($name, $value)=split(/=/,$pair);
	$name=~s/ //g;
	$DUMMY{$name}=$value;
}
$DUMMY{$c_name}=~ s/\+/ /g;
$DUMMY{$c_name}=~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
@pairs=split(/,/,$DUMMY{$c_name});
foreach $pair(@pairs){
	($name, $value)=split(/\:/,$pair);
	$COOKIE{$name}=$value;
}
}

sub SetCookie{
my($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg,
$timer,$date_gmt,$cook,@month,@week,
);
$timer=time;
($secg, $ming, $hourg, $mdayg, $mong, $yearg, $wdayg, $ydayg, $isdstg)=gmtime($timer+$c_valid*24*60*60);
@month=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
@week=('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
$date_gmt=sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",$week[$wdayg],$mdayg,$month[$mong],$yearg+1900,$hourg,$ming,$secg);
$cook="pass:$FORM{'pass'}";
$cook=~s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
$cook=~tr/ /+/;
print "Set-Cookie: $c_name=$cook; expires=$date_gmt\n";
}

sub DelCookie{
print "Set-Cookie: $c_name=;\n";
}


sub CheckPass{
my($fopass,$passflag);
if($passwd eq ""){
	&error("パスワードが設定されていません。");
}
$fopass=$_[0];
if($passwd eq 'admin'){
	if($fopass ne $passwd){
		&error("パスワードが違います。");
	}
}
else{
	$passflag=&MatchPass($fopass,$passwd);
	if(!$passflag){
		&error("パスワードが違います。");
	}
}
return;
}

sub Login{
my($ck,$ok);
&GetCookie;

if($COOKIE{'pass'}){
	$ck=" checked";
	$ok="1";
}

&header;

print <<EOM;
<body>
<p>
<a href="${script}?">掲示板へ</a></p>
<br>
<br>
<br>
<div align=center>
<form method="POST" action="">
<input type="hidden" name="mode" value="menu">
<input type="hidden" name="ok" value="$ok">
<table>
<tr>
<td>パスワード</td>
<td><input size="8" type="password" name="pass" maxlength="8" value="$COOKIE{'pass'}"></td>
<td><input type="submit" value="ログイン"></td>
</tr>
<tr>
<td></td>
<td><input type="checkbox" name="cookie" value="1"$ck>クッキー</td>
<td></td>
</table>

</form>
</div>
</body>
</html>
EOM
exit;

}

sub Menu{

&CheckPass($FORM{'pass'});

if(!$FORM{'ok'} && $FORM{'cookie'}){
	&SetCookie;
}
elsif($FORM{'ok'} && !$FORM{'cookie'}){
	&DelCookie;
}

&header;

print <<EOM;
<body>
<div><a href="javascript:void(0)" onclick="document.fomove_login.submit();" class="navi">ログインへ</a></div>

<br>
<br>
<div align=center>
機能\を選んでボタンを押してください。
<br><br>
<table cellpadding="6">
<tr>
<td>
<form action="" method="POST" style="margin:0px">
<input type="hidden" name="mode" value="kiji">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" value="記事の削除と編集" style="width:150px">
</form>
</td>
</tr>
EOM

if($restmp){
print <<EOM;
<tr>
<td>
<form action="" method="POST" style="margin:0px">
<input type="hidden" name="mode" value="tmp">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" value="仮投稿の登録と削除" style="width:150px">
</form>
</td>
</tr>
EOM
}
print <<EOM;
<tr>
<td>
<form action="" method="POST" style="margin:0px">
<input type="hidden" name="mode" value="multires">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" value="まとめてレス" style="width:150px">
</form>
</td>
</tr>
<tr>
<td>
<form action="" method="POST" style="margin:0px">
<input type="hidden" name="mode" value="dl">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" value="ログのダウンロード" style="width:150px">
</form>
</td>
</tr>
EOM

if($changepass){
print <<EOM;
<tr>
<td>
<form action="" method="POST" style="margin:0px">
<input type="hidden" name="mode" value="pass">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" value="パスワードの変更" style="width:150px">
</form>
</td>
</tr>
EOM
}


print <<EOM;
<tr>
<td>
<form action="" method="POST" style="margin:0px">
<input type="hidden" name="mode" value="iconviewdel">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" value="アイコンの削除" style="width:150px">
</form>
</td>
</tr>
<tr>
<td>
<form action="" method="POST" style="margin:0px">
<input type="hidden" name="mode" value="env">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" value="環境設定" style="width:150px">
</form>
</td>
</tr>
</table>
<form name="fomove_login" action="" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="login">
</form>
</div>
</body>
</html>
EOM
exit;

}

sub Dl{
my(
$buffer,$len,$xflag,$ua,
$filename,@tmp,
);

&CheckPass($FORM{'pass'});

open FILE,$logfile || &error("$logfileが開けません。ファイルを確認してください。");
while(<FILE>){
	$buffer.=$_;
}
close FILE;

$ua=$ENV{'HTTP_USER_AGENT'};

if($ua=~/Win/) {
#	$buffer=~s/\x0A/\x0D\x0A/g;
}
elsif($ua=~/Mac/) {
	$xflag=0;
	if($ua =~ /OS X/){
		$xflag=1;
	}
	elsif($ua =~ /MSIE/){
		if($ua =~ /5\.2/){
			$xflag=1;
		}
	}
	if(!$xflag){
		$buffer=~s/\x0A/\x0D/g;
	}
}


$len=length($buffer);

@tmp=split(/\//,$logfile);
$filename=$tmp[$#tmp];
print "Content-Disposition: attachment; filename=\"$filename\"\n";
print "Content-Type: application/octet-stream\n";
print "Content-length: $len\n\n";
print $buffer;

exit;


}


sub Admin{
my(
$hd,
$no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$pass,$host,
$x,@pagetmp,$page_next,$oya,$pagetmp,$i,$cl,$s,$j,$start,$end,$imgfile,$w,$h
);

&CheckPass($FORM{'pass'});

if($FORM{'editpass'}){
	$FORM{'pass'}=$FORM{'editpass'};
}
if($FORM{'newpass'}){
	$FORM{'pass'}=$FORM{'newpass'};
}

unless(open(FILE, $logfile)){&error("$logfileが開けません。ファイルを確認してください。");}
$hd=<FILE>;

($no,$oya)=split(/,/,$hd);

$x=1;
$page_next=0;

if($pagemax > 0 && $oya > 0){
	while($oya > 0){
		if($FORM{'page'} == $page_next){
			push @pagetmp,"$x";
		}
		else{
			push @pagetmp,"<a href=\"javascript:void(0)\" onclick=\"Move_admin('$page_next');\">$x</a>";
		}
		$x++;
		$page_next=$page_next+$pagemax;
		$oya=$oya-$pagemax;
	}
}
$pagetmp=join(" | ",@pagetmp);

$start=$FORM{'page'}+1;
$end=$FORM{'page'}+$pagemax;


&header;

print <<EOM;
<body>
<p>

<center>
<table border="0" cellspacing="2" cellpadding="0" width="870">
<tr> 
<td><a href="javascript:void(0)" onclick="document.fomove_menu.submit();" class="navi">機能\の選択</a> ＞ 記事の編集と削除</td>
</tr>
</table>
<table width=870> 
<tr>
<td bgcolor="#999999" align=center>
<b><font color="#ffffff">記事の削除と編集</font></b>
</td>
</tr>
<tr>
<td><br>
記事を削除するときは、チェックボックスに印をつけて
削除ボタンを押してください。(複数選択可。親記事を
削除すると、レスも削除されます。) 記事の編集をするときは、
編集ボタンを押してください。入力フォームが
出ますので、それで編集して送信ボタンを押してください。
</td>
</tr>
</table>
<br>
<table width="870">
<tr>
<td>ページ:$pagetmp</td>
</tr>
</table>
<form action="" method="POST">
<input type="hidden" name="mode" value="del">
<input type="hidden" name="pass" value="$FORM{'pass'}">

<table border="0" width="870">
<tr>
<td align="center" width="50"><b>番号</b></td><td align="center" width="100"><b>投稿者</b></td><td align="center" width="120"><b>日付</b></td><td align="center" width="150"><b>タイトル</b></td><td align="center" width="250"><b>コメント</b></td><td width="100" align="center"><b>ホスト</b></td><td align="center" width="50"><input type="submit" name="edt" value="削除"></td><td width="50">&nbsp;</td>
</tr>
EOM
$i=0;
while(<FILE>){
	($no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$imgfile,$w,$h,$pass,$host)=split(/,/,$_);
	if($resno eq ""){
		$cl=" bgcolor=\"#e0e0e0\"";
		$i++;
	}
	else{
		$cl=" bgcolor=\"#eeeeee\"";
	}
	if($i > $end){
		last;
	}
	if($i < $start){
		next;
	}
	$s="";
	$j=0;
	while($message=~/([\xE0-\xEF][\x80-\xBF][\x80-\xBF]|[\xC0-\xDF][\x80-\xBF]|[\x21-\x7E])/go){
		$s.=$1;
		$j++;
		if($j>=10){
			$s.="...";
			$s=~s/<br>//g;
			last;
		}
	}

	print "<tr$cl>\n";
	print "<td align=\"center\">$no</td><td>$name</td><td>$date</td><td>$subject</td><td>$s</td><td>$host</td><td align=\"center\"><input type=\"checkbox\" name=\"number\" value=\"$no\"></td><td align=\"center\"><input type=\"button\" value=\"編集\" onclick=\"Move_edit('$no');\"></td>\n";
	print "</tr>\n";


}
close(FILE);

print <<EOM;
</table>
</form>
<table width="870">
<tr>
<td>ページ:$pagetmp</td>
</tr>
</table>
</center>
<form name="fomove_menu" action="" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="menu">
</form>
<form name="fomove_admin" action="" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="admin">
<input type="hidden" name="page" value="">
</form>
<form name="fomove_edit" action="" method="POST" style="margin:0px" target="s_win">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="edit">
<input type="hidden" name="editnum" value="">
</form>
<script type="text/javascript">
function Move_admin(p){
document.fomove_admin.page.value=p;
document.fomove_admin.submit();
}
function Move_edit(n){
document.fomove_edit.editnum.value=n;
openwin('',500,500);
document.fomove_edit.submit();
}

</script>
</body>
</html>
EOM
exit;
}




sub encode{
my(@saltset,$salt,$newcode);
@saltset=('a'..'z','A'..'Z','0'..'9');
srand(time^$$);
$salt=$saltset[int(rand(@saltset))].$saltset[int(rand(@saltset))];
eval{$newcode=crypt($_[0],$salt);};
if($@){
	&error("暗号化の関数がサポートされていないのでこのサーバーでは使えません。");
}
if($newcode=~/^\$1\$/){
	$newcode=crypt($_[0],'$1$');
}
return $newcode;
}

sub MatchPass{
my($pass,$coded,$salt,$passflag);
$pass=$_[0];
$coded=$_[1];
$passflag=0;
if($coded=~/^\$1\$/){
	if(crypt($pass,'$1$') eq $coded){
		$passflag=1;
	}
}
else{
	$salt=substr($coded,0,2);
	if(crypt($pass,$salt) eq $coded){
		$passflag=1;
	}
}
return $passflag;
}

sub Del{
my(
$hd,$t_no,$oya,$checkkey,$newpass,$flag,
$no,$resno,$dum,$pass,$line,@new,$idx,@delimg,$imgfile_d,
);
&CheckPass($FORM{'pass'});

if($delnum[0] eq ""){
	&error("チェックを入れてください。");
}

&filelock;

unless(open(FILE, $logfile)){
	&error("$logfileが開けません。ファイルを確認してください。");
}
$hd=<FILE>;
($t_no,$oya)=split(/,/,$hd);


$checkkey=0;
$newpass="";
$idx=0;
while(<FILE>){
	$flag=0;
	($no,$resno,$dum,$dum,$dum,$dum,$dum,$dum,$dum,$dum,$dum,$imgfile_d,$dum,$dum,$pass)=split(/,/,$_);
	foreach $line(@delnum){
		if($no == $line || $resno == $line){
			if($imgfile_d){
				push(@delimg,$imgfile_d);
			}
			$flag=1;
			$checkkey=1;
			if($no == $line){
				$newpass=$pass;
				if($resno eq ""){
					$oya--;
				}
			}
			last;
		}
	}
	if($flag==0){
		$new[$idx]=$_;
		$idx++;
	}
}
close FILE;

$hd="$t_no,$oya,\n";

unless(open(FILE, ">$logfile")){&error("$logfileに書き込みできません。パーミッションを確認してください。");}
print FILE $hd;
print FILE @new;
close(FILE);

foreach(@delimg){
	if(-e "$upimgdir$_"){
		unlink("$upimgdir$_") || exit;
	}
}


if($lockflag==1){
	close LOCK;
}

&Admin;

}

sub MakeSess{
my(@saltset,$newcode);
@saltset=('a'..'z','A'..'Z','0'..'9');
srand(time^$$);
$newcode.=$saltset[int(rand(@saltset))];
$newcode.=$saltset[int(rand(@saltset))];
$newcode.=$saltset[int(rand(@saltset))];
$newcode.=$saltset[int(rand(@saltset))];
$newcode.=$saltset[int(rand(@saltset))];
$newcode.=$saltset[int(rand(@saltset))];
$newcode.=$saltset[int(rand(@saltset))];
$newcode.=$saltset[int(rand(@saltset))];
return $newcode;
}

sub Edit{
my(
$hd,$checkkey,
$no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$pass,$bg,
$skinline,$head,$dummy,$temp,$host,$t,$w_o,$sessid,$imgfile,$w,$h
);
&CheckPass($FORM{'pass'});

unless(open(FILE, $logfile)){
	&error("$logfileが開けません。ファイルを確認してください。");
}
$hd=<FILE>;

$checkkey=0;
while (<FILE>){
	($no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$imgfile,$w,$h,$pass,$host,$bg)=split(/,/,$_);
	if($no == $FORM{'editnum'}){
		$checkkey=1;
		last;
	}
}
close(FILE);



if($inlink){
	$message=~s/<a href.*?>//g;
	$message=~s/<\/a>//g;
}

unless(open(HTML, $html)){
	&error("$htmlが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);
($head,$dummy)=split(/<!--msgstart-->/, $skinline);

$head=~s/#name/$name/;
$head=~s/#home/$homepage/;
$head=~s/#email/$email/;
$head=~s/#pass/$COOKIE{'pass'}/;
$head=~s/#subject/$subject/;

$message=~ s/<br>/\n/g;
if(!$tag){
	$message=~ s/&lt;/</g;
	$message=~ s/&gt;/>/g;
}

$head=~s/#message/$message/;
$sessid=&MakeSess;
$temp="\n<input type=\"hidden\" name=\"editnum\" value=\"$FORM{'editnum'}\">\n<input type=\"hidden\" name=\"editpass\" value=\"$FORM{'pass'}\">\n<input type=\"hidden\" name=\"sessid\" value=\"$sessid\">";

$head=~s/<!--num-->/$temp/;
$head=~s/regist/editregist/;

if($icon){
	$head=~s/value=\"$icon\"/value=\"$icon\" selected/i;
}
if($color){
	$head=~s/(name="color" value=\".*?\") checked/$1/i;
	$head=~s/value=\"$color\"/value=\"$color\" checked/i;
}

if($fukidashi){
	$head=~s/value=\"$fukidashi\"/value=\"$fukidashi\" selected/i;
}
if($bg){
	$head=~s/value=\"$bg\"/value=\"$bg\" selected/i;
}

if($imgfile){
	if($w > 50) {
		$w_o=$w;
		$w=50;
		$h=int($w*$h/$w_o);
	}
	$t="<br>現在の画像<br><img src=\"$upimgdir$imgfile\" width=\"$w\" height=\"$h\"><input type=\"checkbox\" name=\"imgdel\" value=\"1\">削除<br>\n";
	$head=~s/(<input.*name="upfile".*?>)/$1$t/;
}


$head=~s/$script//;
print "Content-type: text/html\n\n";
print $head;
print "</body>\n";
print "</html>\n";
exit;
}

sub EditRegist{
my(
$hd,
$no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$pass,$host,$bg,
@new,$idx,$imgfilename,$h,$w,@tmp,$imgfile,$imgfile_d,
);



$FORM{'pass'}=$FORM{'editpass'};
&CheckPass($FORM{'editpass'});

&filelock;

unless(open(FILE, $logfile)){
	&error("$logfileが開けません。ファイルを確認してください。");
}
$hd=<FILE>;


if($inlink){
	$FORM{'message'}=~s/([^=^"])(https?:\/\/[\w\+\.\?\-\/_:~&=#%]+)/$1<a href=\"$2\" target=\"_blank\">$2<\/a>/g;
}

$idx=0;
while(<FILE>){
	($no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$imgfile,$w,$h,$pass,$host,$bg)=split(/,/,$_);
	if($no == $FORM{'editnum'}){
		if($UPFNAME[0]){
			$imgfile_d=$UPFNAME[0];
			if($imgfile && ($imgfile_d ne $imgfile)){
				if(-e "$upimgdir$imgfile"){
					unlink("$upimgdir$imgfile") || &error("$upimgdir$imgfileが削除できません。");
				}
			}
			$imgfile=$imgfile_d;
			$imgfilename=$upimgdir.$imgfile;
			@tmp=split(/\./,$imgfile);
			$ext=$tmp[$#tmp];
			($w,$h)=&GetSize($ext,$imgfilename);
		}
		else{
			if($FORM{'imgdel'}){
				if(-e "$upimgdir$imgfile"){
					unlink("$upimgdir$imgfile") || &error("$upimgdir$imgfileが削除できません。");
				}
				$imgfile="";
				$w="";
				$h="";
			}
		}

		if($FORM{'bg'} && $FORM{'bg'} ne $bg){
			$bg=$FORM{'bg'};
		}
		$_="$no,$resno,$FORM{'name'},$FORM{'fukidashi'},$FORM{'subject'},$FORM{'email'},$FORM{'home'},$date,$FORM{'message'},$FORM{'icon'},$FORM{'color'},$imgfile,$w,$h,$pass,$host,$bg,\n";
	}
	$new[$idx]=$_;
	$idx++;
}

close(FILE);

unless(open(FILE, ">$logfile")){&error("$logfileに書き込みできません。パーミッションを確認してください。");}
print FILE $hd;
print FILE @new;
close(FILE);


if($lockflag==1){
	close LOCK;
}

&End;

}

sub End{
print <<EOM;
Content-type: text/html

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>BBS</title>
<script type="text/javascript">
function cl(){
opener.fomove_admin.submit();
window.close();
}
</script>
</head>
<body onload="cl()">
</body>
</html>
EOM
exit;
}

sub MultiRes{
my($oya,$page_next,@pagetmp,$x,$pagetmp,$start,$end,
$i,$flag,
$no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$pass,$host,
$hd,$no_d,$imgfile,$w,$h
);
&CheckPass($FORM{'pass'});

unless(open(FILE, $logfile)){&error("$logfileが開けません。ファイルを確認してください。");}
$hd=<FILE>;

($no,$oya)=split(/,/,$hd);

$x=1;
$page_next=0;
$pagemax=$adpagemax;
if($pagemax > 0 && $oya > 0){
	while($oya > 0){
		if($FORM{'page'} == $page_next){
			push @pagetmp,"$x";
		}
		else{
			push @pagetmp,"<a href=\"javascript:void(0)\" onclick=\"Move_multires('$page_next');\">$x</a>";
		}
		$x++;
		$page_next=$page_next+$pagemax;
		$oya=$oya-$pagemax;
	}
}
$pagetmp=join(" | ",@pagetmp);

$start=$FORM{'page'}+1;
$end=$FORM{'page'}+$pagemax;


&header;

print <<EOM;
<body>
<p>

<center>
<table border="0" cellspacing="2" cellpadding="0" width="550">
<tr> 
<td><a href="javascript:void(0)" onclick="document.fomove_menu.submit();" class="navi">機能\の選択</a> ＞ まとめてレス</td>
</tr>
</table>
<table width=560> 
<tr>
<td bgcolor="#999999" align=center>
<b><font color="#ffffff">まとめてレス</font></b>
</td>
</tr>
<tr>
<td><br>
入力して、「送信」ボタンを押してください。アイコン、色、名前はスクリプトに設定したものが
使用されます。

</td>
</tr>
</table>
<br>
<table width="560">
<tr>
<td>ページ:$pagetmp</td>
</tr>
</table>
<form action="" method="POST">
<input type="hidden" name="mode" value="multiresregist">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" value="送信する">
<br><br>
EOM
$i=0;
$flag=0;
while(<FILE>){
	($no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$imgfile,$w,$h,$pass,$host)=split(/,/,$_);
	if($resno eq ""){
		$i++;
	}
	if($i > $end){
		last;
	}
	if($i < $start){
		next;
	}
	if($resno eq ""){
		if($i != $start){
			print "<tr>\n<td>&nbsp;この記事にレスをつける<br><textarea cols=\"74\" rows=\"6\" name=\"comment_$no_d\"></textarea></td>\n</tr>\n";
			print "</table><br>\n";
		}
		$flag=0;
		print "<table border=\"0\" width=\"550\" bgcolor=\"#e0e0e0\" class=\"tb\">\n<tr>\n<td>\n";
		print "<table border=\"0\" width=\"550\">\n<tr>\n<td>$subject &nbsp;&nbsp;<b>投稿者</b>: $name &nbsp;&nbsp;<b>投稿日</b>:$date</td>\n</tr>\n<tr>\n<td class=\"com\">$message</td>\n</tr>\n</table>\n";
		print "</td>\n</tr>";
		print "<tr>\n<td><hr width=\"90%\" class=\"line\"></td>\n</tr>";
	}
	else{
		print "<tr>\n<td align=\"right\">";
		print "<table border=\"0\" width=\"520\">\n<tr>\n<td>$subject &nbsp;&nbsp;<b>投稿者</b>: $name &nbsp;&nbsp;<b>投稿日</b>:$date</td>\n</tr>\n<tr>\n<td class=\"com\">$message</td>\n</tr>\n</table>\n";
		print "</td>\n</tr>\n";
		print "<tr>\n<td><hr width=\"90%\" class=\"line\"></td>\n</tr>";

		$flag=1;
	}
	if($resno eq ""){
		$no_d=$no;
	}
}
close(FILE);

if($i){
	print "<tr>\n<td>&nbsp;この記事にレスをつける<br><textarea cols=\"74\" rows=\"6\" name=\"comment_$no_d\"></textarea></td>\n</tr>\n";
	print "</table>";
}

print <<EOM;
<br>
<input type="submit" value="送信する">
</form>
<table width="560">
<tr>
<td>ページ:$pagetmp</td>
</tr>
</table>
</center>
<form name="fomove_menu" action="" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="menu">
</form>
<form name="fomove_multires" action="" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="multires">
<input type="hidden" name="page" value="">
</form>
<script type="text/javascript">
function Move_multires(p){
document.fomove_multires.page.value=p;
document.fomove_multires.submit();
}
</script>
</body>
</html>
EOM
exit;
}

sub GetDate{
my($timer,$sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst,
@week,$date
);
$timer=time;
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)=localtime($timer);
$mon++;
$min=sprintf("%02d",$min);
$sec=sprintf("%02d",$sec);
$year=$year+1900;
@week=('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
$date="$year/$mon/$mday($week[$wday]) $hour:$min";
return $date;
}
sub GetHost{
my($host);
$host=$ENV{'REMOTE_HOST'} || $ENV{'REMOTE_ADDR'};
return $host;
}




sub MultiResRegist{
my($hd,$idx,$i_t,$no,$line,@tmp,
$oya,
@all,
$num,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$pass,$host,$bg,
$flag,@new,@all_d,$aidx,$tmp,$d_no,$d_resno,$delline,$dmy,$last,$lastline,$pastline,$i,$tmpline,@past,
$eflag,@keys,$v,$sub,$dummy

);

&CheckPass($FORM{'pass'});


&filelock;

@keys=keys %COM;
@keys=sort{$a<=>$b}@keys;

unless(open(FILE, $logfile)){
	&error("$logfileが開けません。ファイルを確認してください。");
}

$hd=<FILE>;
($no,$oya)=split(/,/,$hd);
if($no eq ""){
	$no=0;
}
@all=<FILE>;
close FILE;

$date=&GetDate;
$host=&GetHost;

foreach $resno(@keys){
	$flag=0;
	@new=();
	@all_d=();
	$idx=0;
	$aidx=0;
	$eflag=0;
	foreach $v(@all){
		($d_no,$d_resno,$dummy,$dummy,$sub)=split(/,/,$v);
		if($flag==1 && $d_resno == $resno){
			$new[$idx]=$v;
			$idx++;
		}
		elsif($flag==1 && $d_resno eq ""){
			$no++;
			$subject="";
			if($sub){
				$subject="Re: $sub";
			}
			$tmp="$no,$resno,$adname,$fukidashi,$subject,$admail,$adhome,$date,$COM{$resno},$aicon,$adcolor,,,,$pass,$host,$bg,\n";

			$new[$idx]=$tmp;
			$idx++;
			$flag=0;
		}
		elsif($d_no == $resno){
			$flag=1;
			$new[$idx]=$v;
			$idx++;
			$eflag=1;
		}
		if($flag == 0){
			$all_d[$aidx]=$v;
			$aidx++;
		}
	}
	if($flag==1){
		$no++;
		$subject="";
		if($sub){
			$subject="Re: $sub";
		}
		$tmp="$no,$resno,$adname,$fukidashi,$subject,$admail,$adhome,$date,$COM{$resno},$aicon,$adcolor,,,,$pass,$host,$bg,\n";
		$new[$idx]=$tmp;
	}
	if($eflag){
		@all=(@new,@all_d);
		undef @new;
		undef @all_d;
		if(@all > $max){
			if(!$past){
				$delline=pop @all;
				($dmy,$resno)=split(/,/,$delline);
				if($resno eq ""){
					$oya--;
				}
			}
			else{
				$last=$#all;
				$lastline=$all[$last];
				($dmy,$resno)=split(/,/, $lastline);
				if($resno eq ""){
					$oya--;
					$pastline=pop(@all);
					push @past,$pastline;
					&Past(\@past);
				}
				else{
					for($i=$last;$i>0;$i--){
						$tmpline=pop(@all);
						push @past,$tmpline;
						($dmy,$resno)=split(/,/, $tmpline);
						if($resno eq ""){
							last;
						}
					}
					$oya--;
					&Past(\@past);
				}
			}
		}
	}
}

$hd="$no,$oya,\n";
unless(open(FILE,">$logfile")){&error("$logfileに書き込みできません。パーミッションを確認してください。");}
print FILE $hd;
print FILE @all;
close(FILE);

if($lockflag==1){
	close LOCK;
}

&MultiRes;
}

sub Tmp{
my($hd,$no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$pass,$host,$imgfile,$w,$h);

&CheckPass($FORM{'pass'});
unless(open(FILE, $logfile)){&error("$logfileが開けません。ファイルを確認してください。");}
$hd=<FILE>;
($no)=split(/,/,$hd);
close FILE;

&header;

print <<EOM;
<body>
<center>
EOM


print <<EOM;
<table border="0" cellspacing="2" cellpadding="0" width="870">
<tr> 
<td><a href="javascript:void(0)" onclick="document.fomove_menu.submit();" class="navi">機能\の選択</a> ＞ 仮登録の登録と削除</td>
</tr>
</table>
<table width=870> 
<tr>
<td bgcolor="#999999" align=center>
<b><font color="#ffffff">仮登録の登録と削除</font></b>
</td>
</tr>
<tr>
<td><br>
本登録するときは
チェックボックスに印をつけて
登録ボタンを押してください。削除するときは削除ボタンを押してください。
</td>
</tr>
</table>
<br>
<br>
<form action="" method="POST">
<input type="hidden" name="mode" value="tmpdel">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" name="edt" value="登録">
<input type="submit" name="edt" value="削除">
<table border="0" width="870">
<tr>
<td align="center" width="50"><b>番号</b></td><td align="center" width="100"><b>投稿者</b></td><td align="center" width="120"><b>日付</b></td><td align="center" width="150"><b>タイトル</b></td><td align="center" width="350"><b>コメント</b></td><td width="50">&nbsp;</td>
</tr>

<br>
EOM

unless(open(FILE, $restmplog)){&error("$restmplogが開けません。ファイルを確認してください。");}
$hd=<FILE>;

while(<FILE>){
	($no,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$imgfile,$w,$h,$pass,$host)=split(/,/,$_);
	print "<tr bgcolor=\"#eeeeee\">\n";
	print "<td align=\"center\">$no</td><td>$name</td><td>$date</td><td>$subject</td><td>$message</td><td align=\"center\"><input type=\"checkbox\" name=\"number\" value=\"$no\"></td>\n";
	print "</tr>\n";


}
close(FILE);
print <<EOM;
</td></tr></table>
</form>
</center>
<form name="fomove_menu" action="" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="menu">
</form>
</body>
</html>
EOM
exit;
}

sub TmpDel{
my($hd,$no,
$idx,$flag,$line,@new,@delimg,$imgfile_d,$dum,
);

&CheckPass($FORM{'pass'});


unless(open(FILE, $restmplog)){
	&error("$restmplogが開けません。ファイルを確認してください。");
}
$hd=<FILE>;

$idx=0;
while(<FILE>){
	$flag=0;
	($no,$dum,$dum,$dum,$dum,$dum,$dum,$dum,$dum,$dum,$dum,$imgfile_d)=split(/,/,$_);
	foreach $line(@delnum){
		if($no == $line){
			if($imgfile_d){
				push(@delimg,$imgfile_d);
			}
			$flag=1;
			last;
		}
	}
	if($flag==0){
		$new[$idx]=$_;
		$idx++;
	}
}
close FILE;


foreach(@delimg){
	if(-e "$upimgdir$_"){
		unlink("$upimgdir$_") || exit;
	}
}



unless(open(FILE, ">$restmplog")){
	&error("$restmplogが開けません。ファイルを確認してください。");
}
print FILE $hd;
print FILE @new;
close FILE;

&Tmp;


}

sub TmpRegist{
my($hd,$idx,$i_t,$no,$line,@tmp,
$oya,
@all,
$num,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$pass,$host,$bg,
$flag,@new,@all_d,$aidx,$tmp,$d_no,$d_resno,$delline,$dmy,$last,$lastline,$pastline,$i,$tmpline,@past,
$eflag,$l,$v,$w,$h,$imgfile,

);

&CheckPass($FORM{'pass'});

&filelock;

unless(open(FILE, $restmplog)){
	&error("$restmplogが開けません。ファイルを確認してください。");
}
$hd=<FILE>;

$idx=0;
$i_t=0;
while(<FILE>){
	$flag=0;
	($no)=split(/,/,$_);
	foreach $line(@delnum){
		if($no == $line){
			$flag=1;
			last;
		}
	}
	if($flag==0){
		$new[$idx]=$_;
		$idx++;
	}
	else{
		$tmp[$i_t]=$_;
		$i_t++;
	}
}
close FILE;

unless(open(FILE, ">$restmplog")){
	&error("$restmplogが開けません。ファイルを確認してください。");
}
print FILE $hd;
print FILE @new;
close FILE;

unless(open(FILE, $logfile)){
	&error("$logfileが開けません。ファイルを確認してください。");
}

$hd=<FILE>;
($no,$oya)=split(/,/,$hd);
if($no eq ""){
	$no=0;
}
@all=<FILE>;
close FILE;

foreach $l(@tmp){
	($num,$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$imgfile,$w,$h,$pass,$host,$bg)=split(/,/,$l);
	$flag=0;
	@new=();
	@all_d=();
	$idx=0;
	$aidx=0;
	$tmp="$resno,$name,$fukidashi,$subject,$email,$homepage,$date,$message,$icon,$color,$imgfile,$w,$h,$pass,$host,$bg,\n";
	$eflag=0;
	foreach $v(@all){
		($d_no,$d_resno)=split(/,/,$v);
		if($flag==1 && $d_resno == $resno){
			$new[$idx]=$v;
			$idx++;
		}
		elsif($flag==1 && $d_resno eq ""){
			$no++;
			$tmp="$no,".$tmp;
			$new[$idx]=$tmp;
			$idx++;
			$flag=0;
		}
		elsif($d_no == $resno){
			$flag=1;
			$new[$idx]=$v;
			$idx++;
			$eflag=1;
		}
		if($flag == 0){
			$all_d[$aidx]=$v;
			$aidx++;
		}
	}
	if($flag==1){
		$no++;
		$tmp="$no,".$tmp;
		$new[$idx]=$tmp;
	}
	if($eflag){
		@all=(@new,@all_d);
		undef @new;
		undef @all_d;
		if(@all > $max){
			if(!$past){
				$delline=pop @all;
				($dmy,$resno)=split(/,/,$delline);
				if($resno eq ""){
					$oya--;
				}
			}
			else{
				$last=$#all;
				$lastline=$all[$last];
				($dmy,$resno)=split(/,/, $lastline);
				if($resno eq ""){
					$oya--;
					$pastline=pop(@all);
					push @past,$pastline;
					&Past(\@past);
				}
				else{
					for($i=$last;$i>0;$i--){
						$tmpline=pop(@all);
						push @past,$tmpline;
						($dmy,$resno)=split(/,/, $tmpline);
						if($resno eq ""){
							last;
						}
					}
					$oya--;
					&Past(\@past);
				}
			}
		}
	}
}

$hd="$no,$oya,\n";
unless(open(FILE,">$logfile")){&error("$logfileに書き込みできません。パーミッションを確認してください。");}
print FILE $hd;
print FILE @all;
close(FILE);

if($lockflag==1){
	close LOCK;
}

&Tmp;
}

sub Past{
my($ref,$line,$count,$kijicount,$file);
$ref=$_[0];

unless(open(FILE,"$pastcountlog")){&error("$pastcountlogが開けません。");}
$line=<FILE>;
close FILE;
($count,$kijicount)=split(/,/,$line);
if($count eq ""){
	$count=1;
}

if($kijicount eq ""){
	$kijicount=0;
}
$kijicount++;

if($kijicount >= $pastmax){
	$count++;
	$kijicount="";
}

$file=$pastdir.$count.'.log';

open(PAST,">>$file") || &error("$fileが開けません。");
print PAST @{$ref};
close PAST;



$line="$count,$kijicount,\n";

open(FILE,">$pastcountlog") || &error("$pastcountlogが開けません。");
print FILE $line;
close FILE;

}


sub Env{
my($kword,$khost,%CK);
&CheckPass($FORM{'pass'});

if($tag){
	$CK{'tag2'}=" checked";
}
else{
	$CK{'tag1'}=" checked";
}

if($adicon){
	$CK{'adicon2'}=" checked";
}
else{
	$CK{'adicon1'}=" checked";
}
if($tag){
	$CK{'tag2'}=" checked";
}
else{
	$CK{'tag1'}=" checked";
}

if($asciideny){
	$CK{'asciideny2'}=" checked";
}
else{
	$CK{'asciideny1'}=" checked";
}

if($httpdeny){
	$CK{'httpdeny2'}=" checked";
}
else{
	$CK{'httpdeny1'}=" checked";
}
if($past){
	$CK{'past2'}=" checked";
}
else{
	$CK{'past1'}=" checked";
}

if($hanren){
	$CK{'hanren2'}=" checked";
}
else{
	$CK{'hanren1'}=" checked";
}

if($restmp){
	$CK{'restmp2'}=" checked";
}
else{
	$CK{'restmp1'}=" checked";
}


if($hostdeny == 2){
	$CK{'hostdeny3'}=" checked";
}
elsif($hostdeny == 1){
	$CK{'hostdeny2'}=" checked";
}
else{
	$CK{'hostdeny1'}=" checked";
}

if($worddeny){
	$CK{'worddeny2'}=" checked";
}
else{
	$CK{'worddeny1'}=" checked";
}

if($mail == 2){
	$CK{'mail3'}=" checked";
}
elsif($mail == 1){
	$CK{'mail2'}=" checked";
}
else{
	$CK{'mail1'}=" checked";
}
if($inlink){
	$CK{'inlink2'}=" checked";
}
else{
	$CK{'inlink1'}=" checked";
}

if($pastimg){
	$CK{'pastimg2'}=" checked";
}
else{
	$CK{'pastimg1'}=" checked";
}

&header;

foreach(@kinsiword){
	$kword.=$_."\n";
}

foreach(@kinsihost){
	$khost.=$_."\n";
}

$img_style=~s/"/&quot;/g;
$iconsize=~s/"/&quot;/g;
$fukidashisize=~s/"/&quot;/g;

print <<EOM;
<body>
<p>

<center>
<table border="0" cellspacing="2" cellpadding="0" width="550">
<tr> 
<td><a href="javascript:void(0)" onclick="document.fomove_menu.submit();" class="navi">機能\の選択</a> ＞ 環境設定</td>
</tr>
</table>
<table width=560> 
<tr>
<td bgcolor="#999999" align=center>
<b><font color="#ffffff">環境設定</font></b>
</td>
</tr>
</table>
<br>
<div>
<font color="#cc0000">*</font>は入力必須です。
</div>

<form action="" method="POST">
<input type="hidden" name="mode" value="envregist">
<input type="hidden" name="pass" value="$FORM{'pass'}">

<table width="560" cellpadding="4" class="settbl">
<tr>
<td colspan="2" class="komoku" align=center><b>基本設定</b> </td>
</tr>
<tr>
<td width="250" class="bg">管理パスワード</td><td width="400"><input type="password" size="10" name="newpass" value="">(変更するときは入力)</td>
</tr>
<tr>
<td width="250" class="bg">記録する記事の数<font color="#cc0000">*</font></td><td width="400"><input type="text" size="10" name="max" value="$max"></td>
</tr>
<tr>
<td class="bg">1ページに表\示する数<font color="#cc0000">*</font></td><td><input type="text" size="10" name="pagemax" value="$pagemax"></td>
</tr>
<tr>
<td class="bg">タイトルが未入力のときのタイトル</td><td><input type="text" size="30" name="titlealt" value="$titlealt"></td>
</tr>
<tr>
<td class="bg">タグを許可するか</td><td>

1.<input type="radio" name="tag" value="0"$CK{'tag1'}>しない<br>
2.<input type="radio" name="tag" value="1"$CK{'tag2'}>する<br>
</td>
</tr>
<tr>
<td class="bg">URLを自動リンクするか</td><td>

1.<input type="radio" name="inlink" value="0"$CK{'inlink1'}>しない<br>
2.<input type="radio" name="inlink" value="1"$CK{'inlink2'}>する<br>
</td>
</tr>
<tr>
<td class="bg">アップする画像の最大横サイズ</td><td><input type="text" size="20" name="w_max" value="$w_max">
これより大きい場合は縮小します。
</td>
</tr>
<tr>
<td class="bg">アップした画像の回り込みなど</td><td><input type="text" size="50" name="img_style" value="$img_style">
<br>
アップした画像の回り込みやマージンを設定
</td>
</tr>
<tr>
<td class="bg">アイコン画像のサイズ</td><td><input type="text" size="20" name="iconsize" value="$iconsize">
(例)width="50" height="50"
<br>
アイコンの縦横サイズが全て同じときは、指定すると表\示がスムーズになります。
</td>
</tr>
<tr>
<td class="bg">吹き出しのサイズ</td><td><input type="text" size="20" name="fukidashisize" value="$fukidashisize">
(例)width="50" height="50"
</td>
</tr>
<tr>
<td class="bg">管理人専用アイコン</td><td>
管理人専用のアイコンは他のひとに使わせないか<br>
1.<input type="radio" name="adicon" value="0"$CK{'adicon1'}>どうでもよい<br>
2.<input type="radio" name="adicon" value="1"$CK{'adicon2'}>使わせない<br>
<br>
上を2にしたとき<br>
管理人を判別するためのパスワード(英数字8字以内)…<input type="text" size="10" name="adpass" value="$adpass"><br>
(このパスワードと同じパスワードを、投稿するときに記事削除用のパス欄に記入)

</td>
</tr>
<tr>
<td class="bg">管理人専用アイコンのリスト</td><td>
<input type="text" size="20" name="alist1" value="$adiconlist[0]"><br>
<input type="text" size="20" name="alist2" value="$adiconlist[1]"><br>
<input type="text" size="20" name="alist3" value="$adiconlist[2]"><br>
スキンのoptionタグに記入した中から選んで記入(例)kuma12.gif
</td>
</tr>
<tr>
<td colspan="2" class="komoku" align=center><b>セキュリティ</b> </td>
</tr>
<tr>
<td class="bg">書込みに日本語(ひらがな)がないときは弾く</td><td>
1.<input type="radio" name="asciideny" value="0"$CK{'asciideny1'}>弾かない<br>
2.<input type="radio" name="asciideny" value="1"$CK{'asciideny2'}>弾く<br>
</td>
</tr>
<tr>
<td class="bg">投稿に"http"の文字があるときは弾く</td><td>
1.<input type="radio" name="httpdeny" value="0"$CK{'httpdeny1'}>弾かない<br>
2.<input type="radio" name="httpdeny" value="1"$CK{'httpdeny2'}>弾く<br>
<br>
上を2にしたとき<br>
許可するhttpの数を設定…<input type="text" size="10" name="httpdenynum" value="$httpdenynum"><br>
(投稿文の中にここに設定した個数より"http"があれば弾きます)

</td>
</tr>
<tr>
<td class="bg">書き込み禁止にする語句を設定するか</td><td>
1.<input type="radio" name="worddeny" value="0"$CK{'worddeny1'}>しない<br>
2.<input type="radio" name="worddeny" value="1"$CK{'worddeny2'}>する<br>
<br>
上を2したとき禁止する語句を設定<br>
<textarea name="kword" rows="10" cols="30">$kword</textarea>
<br>
禁止語句A<br>
禁止語句B<br>
のように改行して複数登録可
</td>
</tr>
<tr>
<td class="bg">ホスト名でアクセスを拒否するか</td><td>
1.<input type="radio" name="hostdeny" value="0"$CK{'hostdeny1'}>拒否しない<br>
2.<input type="radio" name="hostdeny" value="1"$CK{'hostdeny2'}>書込みのとき拒否<br>
3.<input type="radio" name="hostdeny" value="2"$CK{'hostdeny3'}>書込みと表\示するとき拒否<br>
<br>
上を2か3にしたとき禁止するホスト名を設定<br>
<textarea name="khost" rows="10" cols="30">$khost</textarea>
<br>
禁止ホストA<br>
禁止ホストB<br>
のように改行して複数登録可
(123hoge.ne.jp、456hoge.ne.jpのように変化する部分があるときは同じ部分(この場合hoge.ne.jp)を記入)

</td>
</tr>

<tr>
<td colspan="2" class="komoku" align=center><b>過去ログ</b> </td>
</tr>
<tr>
<td class="bg">過去ログ機能\を使うか</td><td>
1.<input type="radio" name="past" value="0"$CK{'past1'}>使わない<br>
2.<input type="radio" name="past" value="1"$CK{'past2'}>使う<br>
</td>
</tr>
<tr>
<td class="bg">過去ログ1ファイルに記録する数<font color="#cc0000">*</font></td><td><input type="text" size="10" name="pastmax" value="$pastmax"></td>
</tr>
<tr>
<td class="bg">過去ログに画像を表\示するか<font color="#cc0000">*</font></td><td>
1.<input type="radio" name="pastimg" value="0"$CK{'pastimg1'}>表\示しない<br>
2.<input type="radio" name="pastimg" value="1"$CK{'pastimg2'}>表\示する<br>
</td>
</tr>
<tr>
<td colspan="2" class="komoku" align=center><b>まとめてレス</b> </td>
</tr>
<tr>
<td class="bg">1ページに表\示する数(まとめてレス画面用)<font color="#cc0000">*</font></td><td><input type="text" size="10" name="adpagemax" value="$adpagemax"></td>
</tr>
<tr>
<td class="bg">レスにつけるアイコン</td><td>
<input type="text" size="20" name="aicon" value="$aicon">
<br>
スキンの<br>
&lt;option value="./img/kuma15.gif"&gt;くま1&lt;/option&gt;<br>
&lt;option value="./img/kuma16.gif"&gt;くま2&lt;/option&gt;<br>
のようなアイコンの選択部分からレス用のアイコンを選んで./img/kuma15.gifのように設定
</td>
</tr>
<tr>
<td class="bg">レスの文字色</td><td><input type="text" size="20" name="adcolor" value="$adcolor">(例)#000000</td>
</tr>
<tr>
<td class="bg">レスの投稿者名<font color="#cc0000">*</font></td><td><input type="text" size="20" name="adname" value="$adname"></td>
</tr>
<tr>
<td class="bg">レスのホームページ</td><td><input type="text" size="20" name="adhome" value="$adhome"></td>
</tr>
<tr>
<td class="bg">レスのメールアドレス</td><td><input type="text" size="40" name="admail" value="$admail"></td>
</tr>
<tr>
<td colspan="2" class="komoku" align=center><b>その他</b> </td>
</tr>
<tr>
<td class="bg">半角でaaaaaのように長すぎる場合はエラーを出す</td><td>
1.<input type="radio" name="hanren" value="0"$CK{'hanren1'}>出さない<br>
2.<input type="radio" name="hanren" value="1"$CK{'hanren2'}>出す<br>
<br>
上を2にしたとき、エラーを出す横の最大値…<input type="text" size="10" name="hanren_m" value="$hanren_m">
</td>
</tr>
<tr>
<td class="bg">書き込みの際にメールで通知</td><td>
1.<input type="radio" name="mail" value="0"$CK{'mail1'}>しない<br>
2.<input type="radio" name="mail" value="1"$CK{'mail2'}>する(書き込みのみ通知)<br>
3.<input type="radio" name="mail" value="2"$CK{'mail3'}>する(書き込みと削除と編集を通知)<br>
<br>
<br>
上を2か3にしたとき、<br>
sendmailのパス…<input type="text" size="30" name="sendmail" value="$sendmail"><br>
管理者のメールアドレス…<input type="text" size="30" name="mailto" value="$mailto"><br>
</td>
</tr>
<tr>
<td class="bg">レスの仮投稿</td><td>
1.<input type="radio" name="restmp" value="0"$CK{'restmp1'}>しない<br>
2.<input type="radio" name="restmp" value="1"$CK{'restmp2'}>する<br>
</td>
</tr>

</table>

<br>
<input type="submit" value="送信する">
</form>
</center>
<form name="fomove_menu" action="" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="menu">
</form>
</body>
</html>
EOM
exit;
}


sub EnvRegist{
my($i,$adline,$hostline,$wordline,@wordtmp,$evalline,@hosttmp,$coded);

&CheckPass($FORM{'pass'});

if($FORM{'max'} eq ""){
	&error("記録する記事の数が入力されていません。");
}
if($FORM{'pagemax'} eq ""){
	&error("1ページに表示する数が入力されていません。");
}
if($FORM{'pastmax'} eq ""){
	&error("過去ログ1ファイルに記録する数が入力されていません。");
}
if($FORM{'adname'} eq ""){
	&error("レスの投稿者名が入力されていません。");
}

unless(open(FILE,">$commonpl")){
	&error("$commonplが開けません。ファイルを確認してください。");
}


$i=0;
foreach(@adtmp){
	if($_){
		$adline.="'".$_."'";
	}
}
$adline=~s/,$//;

@hosttmp=split(/\n/,$FORM{'khost'});
foreach(@hosttmp){
	$hostline.="'".$_."'".",";
}
$hostline=~s/,$//;

@wordtmp=split(/\n/,$FORM{'kword'});
foreach(@wordtmp){
	$wordline.="'".$_."'".",";
}
$wordline=~s/,$//;

$FORM{'img_style'}=~s/&quot;/"/g;
$FORM{'iconsize'}=~s/&quot;/"/g;
$FORM{'fukidashisize'}=~s/&quot;/"/g;

print FILE <<EOM;
\$max='$FORM{'max'}';
\$pagemax='$FORM{'pagemax'}';
\$titlealt='$FORM{'titlealt'}';
\$tag='$FORM{'tag'}';
\$inlink='$FORM{'inlink'}';
\$w_max='$FORM{'w_max'}';
\$img_style='$FORM{'img_style'}';
\$iconsize='$FORM{'iconsize'}';
\$fukidashisize='$FORM{'fukidashisize'}';
\$adicon='$FORM{'adicon'}';
\$adpass='$FORM{'adpass'}';
\@adiconlist=($adline);
\$asciideny='$FORM{'asciideny'}';
\$httpdeny='$FORM{'httpdeny'}';
\$httpdenynum='$FORM{'httpdenynum'}';
\$worddeny='$FORM{'worddeny'}';
\@kinsiword=($wordline);
\$hostdeny='$FORM{'hostdeny'}';
\@kinsihost=($hostline);
\$past='$FORM{'past'}';
\$pastmax='$FORM{'pastmax'}';
\$pastimg='$FORM{'pastimg'}';
\$hanren='$FORM{'hanren'}';
\$hanren_m='$FORM{'hanren_m'}';
\$mail='$FORM{'mail'}';
\$sendmail='$FORM{'sendmail'}';
\$mailto='$FORM{'mailto'}';
\$restmp='$FORM{'restmp'}';
\$adpagemax='$FORM{'adpagemax'}';
\$aicon='$FORM{'aicon'}';
\$adcolor='$FORM{'adcolor'}';
\$adname='$FORM{'adname'}';
\$adhome='$FORM{'adhome'}';
\$admail='$FORM{'admail'}';
EOM

print FILE "1;\n";
close FILE;

open FILE,"$commonpl" || &error("$commonplが開けません。ファイルを確認してください。");
$evalline = join('',<FILE>);
close(FILE);

$evalline=~s/\n$//;
$evalline=~s/1;$//;

&EvalCheck(\$evalline);

eval $evalline;

if($FORM{'newpass'}){
	$coded=&encode($FORM{'newpass'});
	unless(open(FILE, ">$passlog")){
		&error("passlogに書き込みできません。パーミッションを確認してください。");
	}
	print FILE "\$passwd='$coded';";
	print FILE "\n";
	print FILE "1;\n";
	close FILE;

	$FORM{'pass'}=$FORM{'newpass'};
	$passwd=$coded;
}

&Env;

}

sub EvalCheck{
my($err,$ref);
$err=0;

$ref=$_[0];

if(${$ref}=~/system/){
	$err=1;
}
if(${$ref}=~/`[\x20-\x7E]*`/){
	$err=1;
}
if(${$ref}=~/exec/){
	$err=1;
}
if(${$ref}=~/open/){
	$err=1;
}

if($err){
	&error("危険な文字列が含まれています。");
}

}


sub IconViewDel{
my(@all,$tmphead,$dmy,$tmpicon,$i_name,$i_file,@inamearray,@ifilearray,$head,$k,$i,$icln);
if($upimgdir_http){
	$upimgdir=$upimgdir_http;
}
unless(open(FILE, $iconlog)){
	&error("iconlogが開けません。ファイルを確認してください。");
}
$i=0;
while(<FILE>){
	($i_name,$i_file)=split(/,/,$_);
	$inamearray[$i]=$i_name;
	$ifilearray[$i]=$i_file;
	$i++;
}
close FILE;


&header;
print "<body>\n";

print <<EOM;
<br>
<div align=center>
<table border="0" cellspacing="2" cellpadding="0" width="560">
<tr> 
<td><a href="javascript:void(0)" onclick="document.fomove_menu.submit();" class="navi">機能\の選択</a> ＞ アイコンの削除</td>
</tr>
</table>
<table width=560> 
<tr>
<td bgcolor="#999999" align=center>
<b><font color="#ffffff">アイコンの削除</font></b>
</td>
</tr>
<tr>
<td align="center">
<br>
アイコンを削除するときは、チェックボックスに印をつけて
「削除」を押してください。
</td>
</tr>
</table>

<form action="" method="post">
<input type="submit" value="削除">
<input type="hidden" name="mode" value="icondel">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<table>
<br>
<br>
EOM
$i=0;
$k=0;
foreach(@inamearray){
	print "<tr>\n";
	print qq(<td><input type="checkbox" name="icondelname" value="$ifilearray[$k]"></td><td><img src="${upimgdir}$ifilearray[$i]" alt=""></td><td>$_</td>\n);
	print "</tr>\n";
	$k++;
	$i++;
}
print <<EOM;
</table>

</form>
</div>
<form name="fomove_menu" action="" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="menu">
</form>
</body>
</html>
EOM
exit;

}

sub IconDel{
my($oya,$hd,@all,$no,$pass,@icons,$flag,$ln,$i_name,$i_file,@newicons,$iconline,$passflag,$i);

&CheckPass($FORM{'pass'});

&filelock;
foreach(@icondelname){
	if(-e "$upimgdir$_"){
		unlink("$upimgdir$_") || exit;
	}
}

unless(open(FILE, $iconlog)){
	&error("iconlogが開けません。ファイルを確認してください。");
}
$i=0;
while(<FILE>){
	($i_name,$i_file)=split(/,/,$_);
	$flag=0;
	foreach $ln(@icondelname){
		if($i_file eq $ln){
			$flag=1;
		}
	}
	if(!$flag){
		$newicons[$i++]=$_;
	}
}
close FILE;


unless(open(FILE, ">$iconlog")){
	&error("iconlogが開けません。ファイルを確認してください。");
}
print FILE @newicons;
close FILE;

if($lockflag==1){
	close LOCK;
}

&IconViewDel;
}

sub GetSize{
my($fi,$ex,$w,$h,$size,$i,$mark,$code,$len);

$ex=$_[0];
$fi=$_[1];
$w=0;
$h=0;
if($ex eq "gif"){
	unless(open(GIF,$fi)){
		return(0,0);
	}
	seek(GIF,6,0);
	if(read(GIF,$size,4)){
		($w,$h)=unpack("vv",$size);
	}
	close(GIF);
	return($w,$h);
}
elsif($ex eq "jpg"){
	unless(open(JPEG,$fi)){
		return(0,0);
	}
	binmode JPEG;
	read(JPEG,$b,2);
	for($i=0;$i<10;$i++) {
		unless(read(JPEG,$b,4)){
			last;
		}
		($mark,$code,$len)=unpack("CCn",$b);
		if($mark != 0xFF){
			last;
		}
		elsif($code == 0xC0 || $code == 0xC2) {
      			if(read(JPEG,$b,5)){
     				($h,$w)=unpack("xnn",$b);
			}
     			last;
        	}
		else{
 			unless(read(JPEG,$b,($len-2))){
				last;
			}
		}

	}
    	close JPEG;
	return($w,$h);
}

}

sub filelock{
my($result);
$lockflag = 0;
if(open(LOCK, ">$lockfile")){
	eval{$result=flock(LOCK,2);};
	if($@){&error("このサーバーはflockが使えないので、ロックはオフにしてください。");}
	if($result){
		$lockflag=1;
	}
	else{
		$lockflag=2;
		close LOCK;
	}
	$result=0;
}
else{
	&error("lockファイルがないか、パーミッションが書き込み可になっていません。");
}
if($lockflag == 2){
	&error("書き込みできませんでした。もう一度お試しください。");
}
}


sub header{
print <<EOM;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>BBS</title>
<style type="text/css">
<!--
body{
color: ${t_color};
background-color: ${b_color};
font-family: "ＭＳ Ｐゴシック";
}
p,td,li,div{
font-size: ${t_size};
}
a{
color: ${l_color};
/*text-decoration:none;*/
}
.tb{
border-style:solid;
border-color:#999999;
border-width:1px;
}
.line{
border-color:#999999;
border-style:dashed;
height:1px;
}
.pad{
padding:4px 0px 0px 4px;
}

.settbl{ 
border:1px solid #999999;
border-collapse:collapse;
}
.settbl td{ 
border:1px solid #999999;
border-collapse:collapse;
}
.bg{
background-color:#eeeeee;
}

.komoku{
background-color:#e0e0e0;
}

-->
</style>
<script type="text/javascript">

function openwin(win,w,h){
var features="toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,top=0,left=0,"+"width="+w+",height="+h;
window.open(win,"s_win",features);
}
</script>
</head>
EOM
}



sub error{

if($lockflag==1){
	close LOCK;
}

&header;
print <<EOM;
<body>
<br>
<br>
<p align="center"><font color="#ff0000">ERROR</font><br><br>
EOM
print"$_[0]\n";
print <<EOM;
</p>
<p align="center">
<a href="javascript:void(0)" onclick="document.fomove_enter.submit();" class="navi">管理画面に戻る</a>
</p>
<form name="fomove_enter" action="" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="enter">
</form>
</body>
</html>
EOM
exit;
}
exit;